package MailForm::L10N::ja;

use strict;
use base 'MailForm::L10N::en_us';
use vars qw( %Lexicon );

%Lexicon = (
    # common
    'Mail Form' => 'メールフォーム',
    'Mail Forms' => 'メールフォーム',
    'mailform_setting' => 'メールフォーム',
    'mailform_settings' => 'メールフォーム',
    'Install Sample Mail Form Template' => 'サンプルのメールフォーム用テンプレートをインストール',

    # MailForm.pl
    'Hajime Fujimoto' => '藤本　壱',
    'This plugin allows you to create mail form by Movable Type template.' => 'Movable Typeのテンプレートでメールフォームを作成するためのプラグインです。',
    'Mail Form' => 'メールフォーム',
    'Manage' => '一覧',
    'New' => '新規',
    'Sample template' => 'サンプルテンプレート',
    'To run setting, click below link.' => '設定は、以下のリンクをクリックして、個々のBlogの設定ページの「プラグイン」タブで行ってください。',
    'Run setting of blog \'[_1]\'' => 'Blog「[_1]」の設定',
    'Mail form setting load error' => 'メールフォームの設定を読み込むのに失敗しました',
    'Processing mail' => '処理中です',
    'Now processing mail.<br />please wait for a while.' => 'メールを処理しています。<br />しばらくお待ちください。',
    'Error occured while processing mail.<br />Please send mail again.' => 'メール処理時にエラーが発生しました。<br />お手数ですが再度お送りくださいますようお願いします。',
    'Build error in wait message' => '処理待ちメッセージの再構築時にエラーが発生しました。',
    'Build error in process error message' => '処理エラーメッセージの再構築時にエラーが発生しました。',
    'mailform_setting' => 'メールフォームの設定',
    'Can\'t find root user' => 'ルートユーザーが見つかりません',
    'Can\'t set user to mail form setting' => 'メールフォームの設定にユーザーを追加することができませんでした',

    # MailForm.pm
    'Load setting error' => '設定を読み込むのに失敗しました',
    '(No title)' => '(無題)',
    'Input your mail address.' => 'メールアドレスを入力してください。',
    'Input mail subject.' => '題名を入力してください。',
    'Input correct subject.' => '題名を正しく入力してください。',
    'Mail address is invalid.' => 'メールアドレスの形式が正しくありません。',
    'Input correct mail address.' => 'メールアドレスを正しく入力してください。',
    'Input your name.' => 'お名前を入力してください。',
    'Input your name correctly.' => 'お名前を正しく入力してください。',
    'Input mail body.' => '本文を入力してください。',
    'Input mail body.' => '本文を正しく入力してください。',
    'Confirmation mail addresses isdifferent from mail address.' => 'メールアドレスが確認用のものと一致していません。',
    'Check required checkbox.' => 'チェック必須のチェックボックスをオンにしてください。',
    'Input field [_1].' => 'フィールド [_1] は入力必須です。',
    'Field [_1] is not checked.' => 'フィールド [_1] はチェック必須です。',
    'Mail Body Template load error' => 'メール本文テンプレートの読み込みに失敗しました。',
    'Mail Reply Template load error' => '返信メールテンプレートの読み込みに失敗しました。',
    "Subject : [_1]\nAuthor : [_2] <[_3]>\nMail body :\n[_4]" => "題名　：[_1]\n送信者：[_2] <[_3]>\n本文　：\n[_4]\n",
    'Extra fields :' => '追加フィールド：',
    "\nAuto reply has not done because of mail address was not input.\n" => "\n※メールアドレスが入力されなかったので、自動返信は行いませんでした。\n",
    "Dear [_1]\n\nThank you for emailing to me.\n(This mail is auto reply.)" => "[_1]様\nメールをお送りいただき、ありがとうございました。\n\n※このメールは自動返信です。",
    'Sent mail from mail form.' => 'メールフォームからメールが送信されました',
    'Sending mail failed.' => 'メールを送信することができませんでした。',
    'Thank you for emailing me.' => 'メールをいただきありがとうございました',
    '(and auto reply)' => '（自動返信も送信）',
    'Too many mails have been submitted from you in a short period of time.  Please try again in a short while.' => '誤送信を防ぐため、短時間内でのメールの連続送信はご遠慮いただいております。しばらくしてから、もう一度試してみてください。',    'You are not allowed to send mail.' => 'IPアドレス制限のため、申し訳ありませんが、メールをお送りいただくことができません。',
    'Your email is not allowed to send because of spam check.' => 'スパムチェックによる制限のため、メールをお送りいただくことができません。',
    'Preview template load error' => '送信確認テンプレートの読み込みに失敗しました。',
    'Error template load error' => '送信エラーテンプレートの読み込みに失敗しました。',
    'Post template load error' => '送信完了テンプレートの読み込みに失敗しました。',


    # DoSetting.pm
    'Load permission error' => '権限の読み込みに失敗しました。',
    'You have no permission' => '権限がありません。',
    'Load Setting Error' => '設定の読み込みに失敗しました。',
    'Save Setting Error' => '設定の保存に失敗しました。',
    'Already exists same title' => '同名の設定がすでにあります。',
    'Title is not specified' => '設定のタイトルが入力されていません。',
    'No mail form found.' => 'メールフォームが見つかりません。',
    'Select template' => 'テンプレートを選択してください',
    '(Global)' => '(グローバル)',
    'Load config.yaml error' => 'config.yamlの読み込みに失敗しました。',
    "Template set '[_1]' for mail form installed by '[_2]'." => "'[_2]'がメールフォーム用テンプレートセット'[_1]'をインストールしました。",
    "Mail form setting '[_1]' (ID:[_2]) created by '[_3]'." => "'[_3]'がメールフォームの設定'[_1]'(ID:[_2])を作成しました。",
    "Mail form setting '[_1]' (ID:[_2]) edited by '[_3]'." => "'[_3]'がメールフォームの設定'[_1]'(ID:[_2])を編集しました。",
    "Mail form setting '[_1]' (ID:[_2]) deleted by '[_3]'." => "'[_3]'がメールフォームの設定'[_1]'(ID:[_2])を削除しました。",

    # edit_mailform_setting.tmpl
    'Setting of Mail Form' => 'メールフォームの設定',
    'Insert required MTSetVar tag to mail form template' => 'メールフォームテンプレートに、必須のMTSetVarタグを追加',
    'Rebuild mail form template' => 'メールフォームテンプレートの再構築',
    'Template is not selected' => 'テンプレートが選択されていません',
    'Title is not specified' => '設定のタイトルが指定されていません',
    'Basic setting' => '基本設定',
    'Title of setting' => '設定のタイトル',
    'Description of mail form' => 'メールフォームの概要',
    'Mail address to send' => '送信先のメールアドレス',
    'Detail setting' => '詳細設定',
    'Secondary mail address to send' => '副送信先のメールアドレス',
    'Mail address to send from' => '送信元のメールアドレス',
    'Mail address of author' => '送信者のメールアドレス',
    'Mail address below' => '以下のメールアドレス',
    'Mail subject' => 'メールの題名',
    'Mail form template' => 'メールフォームテンプレート',
    'Preview template' => '送信確認テンプレート',
    'Error template' => '送信エラーテンプレート',
    'Post template' => '送信完了テンプレート',
    'Mail body template' => 'メール本文テンプレート',
    'Auto reply' => '自動返信',
    'Use auto reply' => '自動返信する',
    'Mail address of auto reply' => '自動返信時の送信元のメールアドレス',
    'Reply mail subject' => '返信メールの題名',
    'Reply mail body template' => '返信メールテンプレート',
    'The check item of the form' => 'フォームのチェック項目',
    'Fields to error check' => '未入力エラーをチェックするフィールド',
    'Fields and values to check specific error' => 'エラーと見なす値とそれを適用するフィールドの組み合わせ',
    'Fields to require check on' => 'チェック必須とするフィールド',
    'Confirm mail address' => 'メールアドレスの入力確認',
    'Error check in preview' => '送信確認時にもエラーチェックする',
    'Use Ajax' => 'Ajaxを使用する',
    'Waiting message' => '処理待ち時のメッセージ',
    'Process error message' => '処理エラー時のメッセージ',
    'Mail form setting will lost.' => 'メールフォームの設定は失われます。',
    'Edit template' => 'テンプレートの編集',
    'View mail form' => 'メールフォームの表示',
    'View Mail Form' => 'メールフォームの表示',
    'Author of this mail form' => 'このメールフォームのユーザー',

    # list.tmpl
    'Author' => 'ユーザー',
    'Description' => '概要',
    'Manage Mail Form' => 'メールフォームの管理',
    'Create Mail Form' => 'メールフォームを作成',
    'You have successfully deleted the checked mail form(s).' => 'チェックしたメールフォームを削除しました。',

    # insert_tag.tmpl
    'Insert MTSetVar tag' => 'MTSetVarタグの挿入',
    'MTSetVar tag was inserted as below. Please check that tag below is correctly inserted to template.' => '以下のようにMTSetVarタグを挿入しました。以下のタグがテンプレートに正しく挿入されていることを確認してください。',
    'MTSetVar tag was modified as below. Please check that tag below is correctly inserted to template.' => '以下のようにMTSetVarタグを変更しました。以下のタグがテンプレートに正しく挿入されていることを確認してください。',
    'Required MTSetVar tag' => '必要なMTSetVarタグ',
    'Modified template' => '変更後のテンプレート',
    'Proper MTSetVar tag already exists, so template is not modified.' => '適切なMTSetVarタグがすでにありますので、テンプレートを変更しませんでした。',

    # rebuild.tmpl
    'Rebuilding mail form template failed.' => 'メールフォームテンプレートの再構築に失敗しました。',
    'Mail form template is rebuilt.' => 'メールフォームテンプレートを再構築しました',

    # install_template_setup.tmpl
    'Install sample template' => 'サンプルテンプレートのインストール',
    'Template set' => 'テンプレートセット',
    'Name of mail form template' => 'メールフォームテンプレートの名前',
    'Output filename of mail form' => 'メールフォームの出力ファイル名',
    'Name of preview template' => '送信確認テンプレートの名前',
    'Name of error template' => '送信エラーテンプレートの名前',
    'Name of post template' => '送信完了テンプレートの名前',
    'Name of body template' => 'メール本文テンプレートの名前',
    'Name of reply template' => '返信メールテンプレートの名前',
    'Name of common module of mail form' => 'メールフォーム共通部分モジュールの名前',
    'Preview' => '送信確認',
    'Error' => '送信エラー',
    'Post' => '送信完了',
    'Body' => 'メール本文',
    'Reply' => '返信メール',
    'Common module of mail form' => 'メールフォーム共通部分',
    'Common' => 'メールフォーム共通部分',
    'Install' => 'インストール',

    # install_template.tmpl
    'Install Other Sample Mail Form Template' => '他のメールフォームテンプレートをインストール',
    'Template(s) as below already exist.<br />Please rename.' => '以下のテンプレートはすでに存在しています。<br />名前を変えてください。',
    'Name of template(s) as below are not specified. <br />Please specify name of template.' => '以下のテンプレートは名前が指定されていません。<br />名前を指定してください。',
    'Template(s) as below load error.' => '以下のテンプレートの読み込みに失敗しました。',
    'Template(s) as below save error.' => '以下のテンプレートの保存に失敗しました。',
    'Template(s) as below are created.' => '以下のテンプレートを作成しました。',
    'Back to setting' => '設定に戻る',
);

1;
